# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_safevisionary_msgs/DeviceStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sick_safevisionary_msgs.msg
import std_msgs.msg

class DeviceStatus(genpy.Message):
  _md5sum = "e0b843d6e896d9b6f6a52179435409e1"
  _type = "sick_safevisionary_msgs/DeviceStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# ROS msg definition for internal DEVICE_STATUS struct
std_msgs/Header header
uint8 status
GeneralStatus general_status
uint32 COP_safety_related
uint32 COP_non_safety_related
uint32 COP_reset_required
ActiveMonitoringCase active_monitoring_case
uint8 contamination_level

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sick_safevisionary_msgs/GeneralStatus
# ROS msg definition for internal DEVICESTATUS_DATA_GENERALSTATUS struct
uint8 run_mode_active
uint8 device_error
uint8 application_error
uint8 sleep_mode
uint8 wait_for_input
uint8 wait_for_cluster
uint8 contamination_warning
uint8 contamination_error
uint8 dead_zone_detection
uint8 temperature_warning

================================================================================
MSG: sick_safevisionary_msgs/ActiveMonitoringCase
# ROS msg definition for internal  DEVICESTATUS_DATA_ACTIVE_MONITORING_CASE struct
uint8 monitoring_case_1
uint8 monitoring_case_2
uint8 monitoring_case_3
uint8 monitoring_case_4
"""
  __slots__ = ['header','status','general_status','COP_safety_related','COP_non_safety_related','COP_reset_required','active_monitoring_case','contamination_level']
  _slot_types = ['std_msgs/Header','uint8','sick_safevisionary_msgs/GeneralStatus','uint32','uint32','uint32','sick_safevisionary_msgs/ActiveMonitoringCase','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,status,general_status,COP_safety_related,COP_non_safety_related,COP_reset_required,active_monitoring_case,contamination_level

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DeviceStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.status is None:
        self.status = 0
      if self.general_status is None:
        self.general_status = sick_safevisionary_msgs.msg.GeneralStatus()
      if self.COP_safety_related is None:
        self.COP_safety_related = 0
      if self.COP_non_safety_related is None:
        self.COP_non_safety_related = 0
      if self.COP_reset_required is None:
        self.COP_reset_required = 0
      if self.active_monitoring_case is None:
        self.active_monitoring_case = sick_safevisionary_msgs.msg.ActiveMonitoringCase()
      if self.contamination_level is None:
        self.contamination_level = 0
    else:
      self.header = std_msgs.msg.Header()
      self.status = 0
      self.general_status = sick_safevisionary_msgs.msg.GeneralStatus()
      self.COP_safety_related = 0
      self.COP_non_safety_related = 0
      self.COP_reset_required = 0
      self.active_monitoring_case = sick_safevisionary_msgs.msg.ActiveMonitoringCase()
      self.contamination_level = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_11B3I5B().pack(_x.status, _x.general_status.run_mode_active, _x.general_status.device_error, _x.general_status.application_error, _x.general_status.sleep_mode, _x.general_status.wait_for_input, _x.general_status.wait_for_cluster, _x.general_status.contamination_warning, _x.general_status.contamination_error, _x.general_status.dead_zone_detection, _x.general_status.temperature_warning, _x.COP_safety_related, _x.COP_non_safety_related, _x.COP_reset_required, _x.active_monitoring_case.monitoring_case_1, _x.active_monitoring_case.monitoring_case_2, _x.active_monitoring_case.monitoring_case_3, _x.active_monitoring_case.monitoring_case_4, _x.contamination_level))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.general_status is None:
        self.general_status = sick_safevisionary_msgs.msg.GeneralStatus()
      if self.active_monitoring_case is None:
        self.active_monitoring_case = sick_safevisionary_msgs.msg.ActiveMonitoringCase()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.status, _x.general_status.run_mode_active, _x.general_status.device_error, _x.general_status.application_error, _x.general_status.sleep_mode, _x.general_status.wait_for_input, _x.general_status.wait_for_cluster, _x.general_status.contamination_warning, _x.general_status.contamination_error, _x.general_status.dead_zone_detection, _x.general_status.temperature_warning, _x.COP_safety_related, _x.COP_non_safety_related, _x.COP_reset_required, _x.active_monitoring_case.monitoring_case_1, _x.active_monitoring_case.monitoring_case_2, _x.active_monitoring_case.monitoring_case_3, _x.active_monitoring_case.monitoring_case_4, _x.contamination_level,) = _get_struct_11B3I5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_11B3I5B().pack(_x.status, _x.general_status.run_mode_active, _x.general_status.device_error, _x.general_status.application_error, _x.general_status.sleep_mode, _x.general_status.wait_for_input, _x.general_status.wait_for_cluster, _x.general_status.contamination_warning, _x.general_status.contamination_error, _x.general_status.dead_zone_detection, _x.general_status.temperature_warning, _x.COP_safety_related, _x.COP_non_safety_related, _x.COP_reset_required, _x.active_monitoring_case.monitoring_case_1, _x.active_monitoring_case.monitoring_case_2, _x.active_monitoring_case.monitoring_case_3, _x.active_monitoring_case.monitoring_case_4, _x.contamination_level))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.general_status is None:
        self.general_status = sick_safevisionary_msgs.msg.GeneralStatus()
      if self.active_monitoring_case is None:
        self.active_monitoring_case = sick_safevisionary_msgs.msg.ActiveMonitoringCase()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.status, _x.general_status.run_mode_active, _x.general_status.device_error, _x.general_status.application_error, _x.general_status.sleep_mode, _x.general_status.wait_for_input, _x.general_status.wait_for_cluster, _x.general_status.contamination_warning, _x.general_status.contamination_error, _x.general_status.dead_zone_detection, _x.general_status.temperature_warning, _x.COP_safety_related, _x.COP_non_safety_related, _x.COP_reset_required, _x.active_monitoring_case.monitoring_case_1, _x.active_monitoring_case.monitoring_case_2, _x.active_monitoring_case.monitoring_case_3, _x.active_monitoring_case.monitoring_case_4, _x.contamination_level,) = _get_struct_11B3I5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_11B3I5B = None
def _get_struct_11B3I5B():
    global _struct_11B3I5B
    if _struct_11B3I5B is None:
        _struct_11B3I5B = struct.Struct("<11B3I5B")
    return _struct_11B3I5B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
